#include <iostream>

long long stepen(long long a, long long b){
	int k=a,i,s=1;
	for(i=0; i<b; i++){
		s*=k;
		s%=998244353 ;
	}
	return s ;
}

using namespace std ;
int main() {
	int n,m,i,j,k,c,suma=0 ;
	cin >> n >> m ;
	int b[m+1],a[n+1];
	b[0]=0;
	a[0]=0;
	for(i=1; i<=m; i++){
		cin >> k ;
		b[i]=k ;
	}
	for(i=1; i<=n; i++){
		a[i]=i ;
	}
	for(i=0; i<=n-m; i++){
		for(j=1; j<=m; j++){
			a[i+b[j]]=a[i+j] ;
		}
	}
	cin >> c ;
	for(i=1; i<=n; i++){
		suma+=stepen(c,i)*a[i];
		suma%=998244353 ;
	}
	cout << suma ;

	
	return 0;
}